All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Query |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

*** This class is subject to change. ***

## com.sas.iquery.metadata.business.step
Class CompoundStep

    com.sas.iquery.metadata.business.step.CompoundStep

All Implemented Interfaces:
  Base, BusinessModelResourceReferencer, ModelItem, StepInterface, UsabilityInterface, PropertyChangeListenee, com.sas.util.LocalizableToStringInterface, java.beans.PropertyChangeListener, java.lang.Cloneable, java.util.EventListener

    @SASScope(value="ALL")
    @SubjectToChange
    public class CompoundStep

implements StepInterface, java.lang.Cloneable, com.sas.util.LocalizableToStringInterface

Enables a user to group a set of steps together. A compound step brings the notion of parentheses within the list of steps. For example, (Blue Car Models with Sales GT 1M) and (Red Car Models with Sales GT 2M). CompoundSteps, like simple Steps are managed by the StepManager. Each CompoundStep can contains any number of Steps or CompoundSteps.

The following is a brief description of how AND/OR is applied by step

- OR condition for filter is: Filter( (Blue Car Models with Sales GT 1M) OR (Red Car Models with Sales GT2M) )
- OR condition for ranking is: {TopCount(Blue Car Models Top 25), BottomCount(Blue Car Models Bottom 25))
- OR condition for navigation is: Union(Blue Car Models.children, Red Car Models.children)
- OR condition for a mixed steps of ranking and filter is: Union(TopCount(Blue Car Models Top 25), Blue Car Model with Sales GT 1M)
- OR condition for a mixed steps of ranking and filter using NOT: Except(TopCount (Blue Car Models Top 25), Blue Car Model with Sales GT 1M)

- AND condition for filter is: Filter( (Blue Car Model with Sales GT 1M) AND (Red Car Models with Sales GT 2M) )
- AND condition for ranking is: {TopCount(BottomCount(Blue Car Model, 100), 25)}
- AND condition for navigation is: Intersection(Blue Car Model.children, Red Car Models. children)
- AND condition for navigation using NOT is: Intersection (Blue Car Model. children, Red Car Models. children)
- AND condition for mixed steps of ranking and filter is: TopCount(Filter(BlueCar Model with Sales GT 1M), 25)

See Also:
  `DataItem`, `StepInterface`

Field Summary
`static java.lang.String` | `AND_CONDITION` Definition of an AND condition in a compound step.
`static java.lang.String` | `EVENT_CONDITION_TYPE_CHANGED` Indication that a condition defined in a step has changed
`static java.lang.String` | `EVENT_NEGATION_CHANGED` Indication that a NOT condition in the MDX phrase has changed.
`static java.lang.String` | `EVENT_STEPS_CHANGED` Indication that the list of steps defined in a compound step has changed
`static java.lang.String` | `OR_CONDITION` Definition of an OR condition in a compound step.

Fields inherited from interface com.sas.iquery.metadata.business.ModelItem
`EVENT_OBJECT_PROPERTY_CHANGED`

Fields inherited from interface com.sas.iquery.metadata.business.Base
`EVENT_OBJECT_DEFINITION_CHANGED`

Constructor Summary
`CompoundStep()` A constructor that initializes a CompoundStep

Method Summary
`void` | `addStep(StepInterface step)` This method adds a Step to the ordered list of Steps.
`java.util.List<StepInterface>` | `getSteps()` This method returns an ordered list of Steps.
`java.util.List<java.lang.String>` | `getStepsConditions()` This method returns an ordered list of the condition (AND/OR) applied to steps.
`boolean` | `isNegated()` Tests if the expression defined in the compound step are negated or defined with a NOT
`void` | `setConditionType(java.lang.String stepCondition)` This method defines whether AND/OR condition for step connection.
`void` | `setNegated(boolean isNegated)` Set that this compound step is negated

Methods inherited from interface com.sas.iquery.metadata.business.BusinessModelResourceReferencer
`getResources`

Methods inherited from interface com.sas.iquery.metadata.PropertyChangeListenee
`addListener, getListeners, removeListener`

Methods inherited from interface com.sas.iquery.metadata.business.UsabilityInterface
`getReasonsUnusable, isUsableInQuery`

Field Detail

### EVENT_NEGATION_CHANGED

    public static final java.lang.String EVENT_NEGATION_CHANGED

  Indication that a NOT condition in the MDX phrase has changed.

  See Also:
    Constant Field Values

### EVENT_STEPS_CHANGED

    public static final java.lang.String EVENT_STEPS_CHANGED

  Indication that the list of steps defined in a compound step has changed

  See Also:
    Constant Field Values

### EVENT_CONDITION_TYPE_CHANGED

    public static final java.lang.String EVENT_CONDITION_TYPE_CHANGED

  Indication that a condition defined in a step has changed

  See Also:
    Constant Field Values

### AND_CONDITION

    public static final java.lang.String AND_CONDITION

  Definition of an AND condition in a compound step.

  See Also:
    Constant Field Values

### OR_CONDITION

    public static final java.lang.String OR_CONDITION

  Definition of an OR condition in a compound step.

  See Also:
    Constant Field Values

Constructor Detail

### CompoundStep

    public CompoundStep()

  A constructor that initializes a CompoundStep

Method Detail

### addStep

    public void addStep(StepInterface step)

  This method adds a Step to the ordered list of Steps.

  Parameters:
    `step` - The step to be added to the CompoundStep

### isNegated

    public boolean isNegated()

  Tests if the expression defined in the compound step are negated or defined with a NOT

### setNegated

    public void setNegated(boolean isNegated)

  Set that this compound step is negated

### setConditionType

    public void setConditionType(java.lang.String stepCondition)

  This method defines whether AND/OR condition for step connection. If an AND or OR must be applied, If neither is used, OR is assumed.

  Parameters:
    `stepCondition` - The stepCondition defines whether this is a AND/OR condition.

### getSteps

    public java.util.List<StepInterface> getSteps()

  This method returns an ordered list of Steps. A CompoundStep can contain CompoundSteps or Steps, but can't directly or indirectly contain itself.

  Returns:
    An ordered list of Steps

### getStepsConditions

    public java.util.List<java.lang.String> getStepsConditions()

  This method returns an ordered list of the condition (AND/OR) applied to steps.

  Returns:
    An ordered list of step conditions

*** This class is subject to change. ***

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Query |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.